import java.awt.*;
import java.awt.event.*;
import java.lang.Math;
public class PoissonsEq extends Frame
{  public int ID1, ID2;public double ER;
   public double LeftP, TopP, sX, sY;
   public double currentX, currentY; // ݂̕`ʒu
   public PoissonsEq()
   {  setSize(600,700);
      addWindowListener(new WindowAdapter()
      { public void windowClosing(WindowEvent e){System.exit(0);}
      });
   }
   private double[][][] Initial(int KX, int KY)
   { double [][][] U = new double[2][KX+1][KY+1];
     for(int j = 0; j <= KY; j++) for(int i = 0; i <= KX; i++)for (int k = 0; k < 2; k++) U[k][i][j] = 0;
     return U;
   }
   private double[][] InitialPoisson(int KX, int KY, double DX, double DY, boolean Pflag)
   { int MX = KX + 1; int MY = KX + 1;
     double [][] F = new double[MX][MY];
     for(int j = 0; j < MY; j++) for(int i = 0; i < MX; i++)
     {  if(Pflag) F[i][j] = 80 * (DX * (double)(MX - i) + DY * (double)(MY - j));
        else      F[i][j] = 0;
     }
     return F;
   }
   private void BoundaryCondition(double [][][] U, int KX, int KY, double DX, double DY)
   {  for(int k = 0; k < 2; k++)
      { for(int i = 0; i<= KX; i++){ U[k][i][0] = 0; U[k][i][KY] = 16;}
        for(int j = 0; j<= KY; j++){ U[k][0][j] = 0; U[k][KX][j] =  8;}
      }
  }
  private double[][][] Comp(Graphics g, int KX, int KY, int NN, double EPS, boolean Pflag)
  { if(Pflag) g.drawString(" |A\̕ = "+ ER, 100, 50);
    else      g.drawString(" vX̕ = "+ ER, 100, 50);
    double DX = 1.0 / KX; double DY = 1.0 / KY;
    double [][][] U = Initial(KX, KY);
    double   [][] F = InitialPoisson(KX, KY, DX, DY, Pflag);
    BoundaryCondition(U, KX, KY, DX, DY);
    double F1 = 1.0 / (DX * DX);
    double F2 = 1.0 / (DY * DY);
    double F3 = 0.5 / (F1 + F2);
    // ʌvZ
    ID1 = 1; ID2 = 0;
    for(int N = 0; N < NN; N++)
    {
       int ID = ID1; ID1 = ID2; ID2 = ID; ER = 0;
       for(int j = 1; j< KY; j++)
          for(int i = 1; i< KX; i++)
          {  U[ID2][i][j] = F3 * (F1 * (U[ID1][i + 1][j] + U[ID1][i][j + 1]) + 
                            F2 * (U[ID1][i - 1][j] + U[ID1][i][j - 1]) + F[i][j]);
             if(Math.abs(U[ID2][i][j]) > EPS)
             {   double E = Math.abs((U[ID2][i][j] - U[ID1][i][j]) / U[ID2][i][j]);
                 if(E > ER) ER = E;
             }
          }
       if((N % 50) == 0) g.drawString(""+ N, 50, 50 + (N / 50) * 16);
       if(ER < EPS) break;
     }
     g.drawString("덷 = "+ ER, 300, 50);

     return U;
  }
   public void drawInit(double X1, double Y1, double SX, double SY)
   {  LeftP = X1; TopP = Y1; sX = SX; sY = SY;
   }
   public int Xpos(double X)
   {  return (int)(LeftP + X * sX);}
   public int Ypos(double Y)
   {  return (int)(TopP  + Y * sY);}
   public void drawLine(Graphics g, double X1, double Y1, double X2, double Y2)
   {  g.drawLine(Xpos(X1),Ypos(Y1),Xpos(X2),Ypos(Y2));
   }
   public void drawPoint(Graphics g, double X, double Y)
   {  g.fillOval(Xpos(X)-2,Ypos(Y)-2,4,4);
   }
   public void drawCircle(Graphics g, double X, double Y)
   {  g.drawOval(Xpos(X)-2,Ypos(Y)-2,4,4);
   }
   public void drawRect(Graphics g, double X, double Y)
   {  g.drawRect(Xpos(X)-2,Ypos(Y)-2,4,4);
   }
   public boolean Draw(Graphics g, double X, double Y, boolean Flag)
   {  if(Flag) drawLine(g, currentX, currentY, X, Y);
      currentX = X; currentY = Y;
      return true;
   }
   private double round(double D,int N)
   {  double DN=10*Math.pow(10.0,(double)(N-1));
      return Math.rint(D*DN)/DN;
   }
   private double MaxValue(double[][][]U, int KX,int KY)
   {  double V = U[0][0][0];int i,j,k;
      for(k = 0; k < 2; k++) for(i = 0; i < KX; i++)
          for(j = 0; j < KY; j++) if(U[k][i][j]>V) V= U[k][i][j];
      return V;
   }
   private double MinValue(double[][][]U, int KX,int KY)
   {  double V = U[0][0][0];int i,j,k;
      for(k = 0; k < 2; k++) for(i = 0; i < KX; i++)
          for(j = 0; j < KY; j++) if(U[k][i][j]<V) V= U[k][i][j];
      return V;
   }
   private void drawResult(Graphics g, double [][][]U, int KX, int KY,int W, int H)
   { double minV=MinValue(U,KX,KY);
     double maxV=MaxValue(U,KX,KY);
     double DH=(maxV-minV)/256; int i,j;
     for(i = 0; i < KX; i++) for(j = 0; j < KY; j++)
     {   int CH = (int)(U[ID2][i][j] / DH); if(CH>255) CH=255;
         g.setColor(new Color(CH,CH, CH));
         g.fillRect(Xpos(i),Ypos(j),W,H);         
     }
     g.setColor(new Color(0,0, 0));
   }
   public void paint(Graphics g)
   {  g.setColor(new Color(0,0, 0));
      drawInit( 100, 100, 2,2);
      setTitle("|A\yуvX̕");
      double [][][]U;
      int KX=100; int KY=100; int NN = 10000; double ERR = 0.01;
      // |A\̂̕ƂŌ̈true,
      // vX̂̕ƂŌ̈falseɂ.
      U= Comp(g, KX, KY, NN, 0.0001, true); 
      drawResult(g, U, KX, KY, 2, 2);
   } 
   public static void main(String[] args)
   {  Frame w = new PoissonsEq();
      w.setVisible(true);
   }
}
